local mod = MorgDKP2:NewModule("Percent")
local L = LibStub("AceLocale-3.0"):GetLocale("MorgDKP2")

local mdkp = MorgDKP2

mod.modName = L["Percent DKP"]
mod.modref = "Percent"

local Player = UnitName("player")
local floor = math.floor
local fmt = string.format
local db

local defaults = { 
	profile = {
		percent = 50,
		percenttake = nil,
	},
}

function mod:GetOptions()
	return options
end

function mod:IsDKP()
	return true
end

function mod:GetName()
	return mod.modName, mod.modref
end

function mod:OnInitialize()
	self.db = mdkp.db:RegisterNamespace("Percent", defaults)
	
end

function mod:OnEnable()
	db = mdkp.db.profile
	db.moduleON["Percent"] = true
	
end

function mod:OnDisable()
	db.moduleON["Percent"] = nil
end

function mod:UpdateDB()
	db = mdkp.db.profile
end

function mod:Toggle(info, v)
	mdkp.db.profile.modules.Percent = v
	if v then mod:Enable()
	else mod:Disable() end
	self:DKPChange(mod.modName)
end

function mod:SetOpt(info, v)
	local db = mod.db.profile
	local opt = info[#info]
	db[opt] = v
end

function mod:GetOpt(info)
	local db = mod.db.profile
	local opt = info[#info]
	return db[opt]
end

function mod:GetPlayerPoints(name, POOL, showearned)
	if not showearned or showearned == 1 then return db.info[name][POOL].points end
	if showearned == 2 then return db.info[name][POOL].earned
	elseif showearned == 3 then return db.info[name][POOL].attend
	end
end

function mod:GetItemValue(itemid, player, POOL)
	local points = self:GetPlayerPoints(player, POOL)
	local itempoints = floor((points * self.db.profile.percent/100)  + 0.5)
	if self.db.profile.percenttake then
		if mdkp.querytooltips[itemid] then
			for  i,v in pairs(mdkp.querytooltips[itemid]) do
				if v[1].n == player then
					if v[2] == "TAKE" then itempoints = mdkp.origitempoints[itemid]  end
					break
				end
			end
		end
	end
	itempoints = self:GetTAKEModeValue(itemid, itempoints, player)
	return itempoints
end

function mod:ItemRecorded(id, looter, POOL, points, itempoints, link)
	if looter == L["Bank"] then return end
	points = points - itempoints
	self:AwardItem(id, looter, POOL, points, itempoints, link)
end

function mod:ItemRebate(id, looter, POOL, itempoints, link)
	if not id or looter == L["Bank"] then return end
	self:AdjustDKPPoints(looter, looter, POOL, nil, itempoints)
end
